#include "file/interface/dfitem/dfitem_menu.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDFItemMenu::CDFItemMenu( NodeTypeID _type ) : CDFItemBase( _type )
{

}

CDFItemMenu::~CDFItemMenu()
{

}

int CDFItemMenu::Modify( CModifyData &modifyData )
{
    int i;
    unsigned int offs = modifyData.offsFlash, offsChilds;
    CDFItemBase *item;
    
    // Daten von Bedien einlesen
    StructBedien bedien = *(StructBedien*)&modifyData.file->m_flash[offs - FLASH_KONFIG_START];
    ChangeOrderLong( (unsigned char*)&bedien.P );
    offs += sizeof(StructBedien);
    
    // Daten von BedienMenue einlesen
    StructMenue &menue = *(StructMenue*)&modifyData.file->m_flash[offs - FLASH_KONFIG_START];
    ChangeOrderLong( (unsigned char*)&menue.P );
    
    // Namen aendern?
    strcpy( menue.Name1, LookupReplace( modifyData, menue.Name1 ).c_str() );
    strcpy( menue.Name2, LookupReplace( modifyData, menue.Name2 ).c_str() );
    
    offs += sizeof(StructMenue);
    
    // Daten aller Eintraege einlesen
    for ( i = 0; i < (int)menue.EintragCnt; ++i )
    {
        // Pointer des Eintrags berechnen
        offsChilds = menue.P + i * sizeof(unsigned int);	
        
        offsChilds = *(unsigned int*)&modifyData.file->m_flash[offsChilds - FLASH_KONFIG_START];
        ChangeOrderLong( (unsigned char*)&offsChilds );
        
        item = new CDFItemMenuChoice();
        LinkEndChild( item );
        modifyData.offsFlash = offsChilds;
        item->Modify( modifyData );
    }

    // Adresse zurueckkonvertieren
    ChangeOrderLong( (unsigned char*)&menue.P );
    
    return 1;
}
